/*
 * <aisl/instance.h>
 *
 * Copyright (c) 2017-2019 by Löwenware Ltd.
 *
 * Project homepage: https://lowenware.com/aisl/
 *
 */

#ifndef AISL_INSTANCE_H_60576F41_454C_4189_B91A_F40501132230
#define AISL_INSTANCE_H_60576F41_454C_4189_B91A_F40501132230

#include <stdint.h>
#include <stdarg.h>
#include <aisl/types.h>
#include <aisl/config.h>



/* Initialization functions */

aisl_t
aisl_new( aisl_config_t config );


void
aisl_free( aisl_t instance );


aisl_server_t
aisl_listen( aisl_t instance, const char * address, uint16_t port );


#ifndef AISL_WITHOUT_SSL

aisl_status_t
aisl_set_ssl( aisl_t           instance,
              const char     * hostname,
              const char     * key_file,
              const char     * crt_file );

#endif

/* Callbacks and Events functions */

aisl_status_t
aisl_set_callback( aisl_t             instance,
                   void             * source,
                   aisl_event_t       event,
                   aisl_callback_t    callback );


aisl_status_t
aisl_raise( aisl_t instance, void * source, aisl_event_t event, ... );


aisl_status_t
aisl_raise_vl( aisl_t            instance,
               void            * source,
               aisl_event_t      event,
               va_list           args );


void
aisl_unset_callback_for( aisl_t instance, void * source );


/* Control functions */

aisl_status_t
aisl_run_cycle( aisl_t instance );


const char *
aisl_get_error( aisl_t instance );


aisl_status_t
aisl_sleep( aisl_t instance, uint32_t usec );


#endif /* !AISL_INSTANCE_H */
