#ifndef AISL_CLIENT_H_164FE6B2_E5D4_4968_B50F_823E30E8F777
#define AISL_CLIENT_H_164FE6B2_E5D4_4968_B50F_823E30E8F777

#include <time.h>
#include <arpa/inet.h>


#include <openssl/err.h>
#include <openssl/ssl.h>

#include <aisl/client.h>
#include "server.h"
#include "list.h"

#define CLIENT_FLAG_KEEPALIVE (1<<0)
#define CLIENT_FLAG_HANDSHAKE (1<<1)

#define CLIENT(x) ((aisl_client_t)x)

/* constructor -------------------------------------------------------------- */

aisl_status_t
aisl_client_accept(aisl_client_t * self, aisl_server_t server);

/* destructor --------------------------------------------------------------- */

void
aisl_client_free(aisl_client_t self);

/* all regular client routines. return true if something happened ----------- */

bool
aisl_client_touch(aisl_client_t self);

/* check if communication time with client is expired ----------------------- */

bool
aisl_client_is_timeout(aisl_client_t self);

/* -------------------------------------------------------------------------- */

void
aisl_client_close(aisl_client_t self);

/* -------------------------------------------------------------------------- */

#endif /* !AISL_CLIENT_H */
